using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Actions;
using DevExpress.Persistent.Base;
using Xafari.MQ;

namespace XafariMQSample.Module.Controllers
{
     public class ViewController1 :ViewController
    {
        private int _index = 0;
        private const string MQTag = "MQTag";
        public ViewController1()
        {
            var addMessageToQueueAction = new SimpleAction(this, "AddMMessageToQueue", PredefinedCategory.Unspecified){Caption = "Add message to Queue"};
            addMessageToQueueAction.Execute += OnAddMessageToQueueActionExecute;
        }

        private void OnAddMessageToQueueActionExecute(object sender, SimpleActionExecuteEventArgs e)
        {
            using (var mqObjectSpace = MQManager.Instance.CreateObjectSpace())
            {
                var messageData = mqObjectSpace.CreateObject<MessageData>();
                ++_index;
                messageData.Index = _index;
                mqObjectSpace.CommitChanges();
                MQManager.Instance.InsertMessage(messageData, MQTag, "Message "+_index);
            }
        }
    }
}
