using System;
using DevExpress.ExpressApp;
using System.Collections.Generic;
using DevExpress.ExpressApp.Updating;
using Xafari;
using Xafari.Server;
using XafariMQSample.Module;


namespace XafariMQSample
{
      public sealed class XafariReportsMOSampleModule : ModuleBase
    {
        private const string MQTag = "MQTag";

        public XafariReportsMOSampleModule()
        {
            RequiredModuleTypes.Add(typeof(XafariModule));
            RequiredModuleTypes.Add(typeof(Xafari.MQ.XafariMQModule));
            RequiredModuleTypes.Add(typeof(XafariServerModule));
        }
        public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB)
        {
            return ModuleUpdater.EmptyModuleUpdaters;
        }

        public override void Setup(XafApplication application)
        {
            base.Setup(application);

            XafTypesInfo.Instance.RegisterEntity("MessageData", typeof(MessageData));
            XafTypesInfo.Instance.RegisterEntity("MessageLog", typeof(MessageLog));

            application.SettingUp += (sender, args) =>
            {
                if (this.Application.IsSharedApplication()) return;

                XafariServerModule.DataObserver.ServerHandlersStrategy.RegisterHandler(MQTag,
                    (app, messageKey, userName) => new MessageHandler(app,messageKey));
            };

        }
    }
}
